import 'package:flutter/foundation.dart';
import 'package:shared_preferences/shared_preferences.dart';
import 'package:wowit/common.dart';
import 'package:wowit/methods.dart';
import 'package:wowit/sql_service.dart';

class ImageByID {
  static String prefsImage = 'prefImage';

  static String getUrlImage(int id) {
    String idImage = id.toString();
    if (Common.mapImageURL.containsKey(idImage)) {
      return Methods.getString(Common.mapImageURL, idImage);
    } else {
      return Common.DEFAULT_IMAGE_URL;
    }
  }

  static Future<void> initHinhAnh({
    List<Map<String, Object>>? dtImage,
    bool reload = false,
  }) async {
    try {
      List<String> listLanguage = [];
      const pattern = '[(=-|';
      Map<String, String> valueImage = {};
      SharedPreferences prefs = await SharedPreferences.getInstance();
      if (prefs.getStringList(prefsImage) == null || reload) {
        if (dtImage == null || dtImage.isEmpty || reload) {
          var data = await SQLService.execute(
            'sp_getImage',
          );
          dtImage = Methods.getList(data, 'dsHinhAnh');
        }

        for (var item in dtImage) {
          listLanguage.add(Methods.getInt(item, 'ID').toString() +
              pattern +
              Methods.getString(item, 'hinhAnh_image_path'));
        }
        if (Common.uid > 0) {
          await SQLService.execute('sp_setHasMapImage',
              params: {'@uid': Common.uid});
        }
        if (prefs.getStringList(prefsImage) != null) {
          await prefs.remove(prefsImage);
        }
        await prefs.setStringList(prefsImage, listLanguage);
      }
      List<String> list = prefs.getStringList(prefsImage) ?? [];
      for (var itemList in list) {
        var convert = itemList.split(pattern);
        if (convert.length > 1) {
          String imageID = convert[0].toString().toUpperCase();
          if (!valueImage.containsKey(imageID)) {
            valueImage[imageID] = convert[1];
          }
        }
      }
      Common.mapImageURL = valueImage;
    } catch (ex) {
      if (kDebugMode) {
        print('initHinhAnh exception: ' + ex.toString());
      }
    }
  }
}
